/******************************************************************************/
/*                ԊOR̃LZMM                          */
/*                                                        by : S.Suzuki       */
/******************************************************************************/
/*  : (1)̃vOATtiny44A-PUpłB                             */
/*      : (2)ԊOR̃LZMƂ́A38KHz̃pXgłB        */

#include <avr/io.h>
#include <avr/interrupt.h>

#include "hdwareInfo.h"
#include "IrRcCanSend.h"

/******************************************************************************/
/*  : ^C}Õ\[XNbNi=PCLKj́AVXeNbNƓ 8MHz    */
/*      : ł̂ƂB                                                  */
/* Ql : NbNPCLKƕ̎g                                        */
/*      :  PCLK      =      8MHz (0.125uS)                                    */
/*      :  PCLK/8    =      1MHz (1uS)                                        */
/*      :  PCLK/64   =    125KHz (8uS)                                        */
/*      :  PCLK/256  =  31.25KHz (32uS)                                       */
/*      :  PCLK/1024 = 7.8125KHz (128uS)                                      */

#define CLK_CNT0	PCLK				/* PCLK = 8MHz */
#define CLK_SEL		(0x01)				/* ^C}ÕNbNI = 8MHz (=PCLK) */
#define VAL_OCR0A	(CLK_CNT0/38000)	/*  Pi26.25Sj̎ԍ쐬l */
#define	VAL_OCR0B	(VAL_OCR0A*2/3)		/* 2/3i17.50Sj̎ԍ쐬l */

static WORD	s_wPulseCount;				/* w肳ꂽoԂ̃pX */

/******************************************************************************/
/*                            ^C}Ȍ                                */
/******************************************************************************/
/*  : OCnA,OCnBo͂ɎgpI/O|[ǵATCCRnA̐ݒɂĎI    */
/*      : OCnA,OCnBo͂ɂȂ邪AeI/O|[gDDRx='1'ݒɂďo̓[h  */
/*      : ɂĂKvB                                              */
/* Ql : [qOC0BICP1͓si6pinĵߓgpłȂB          */
/*      : IrRcReceiveICP1gp̂ŁAOC0BgPWM͂łȂB*/
/*      : Ȃ̂ŁAł͒[qOC0AgA\tgEFAON/OFFăpX  */
/*      : o͂B                                                          */
/*  : Ȃ                                                                */
/* ߒl : Ȃ                                                                */

void Init_TIMER0(void)
{
	/* LZMo͂I/O|[g̏ */
	CANP_PORT &= ~CANP_BIT;			/* LZMo͒[q'0'o͂Ă */
	CANP_DDR  |= CANP_BIT; 			/* LZMo͒[qo̓|[gɂ  */
	/* ^C}OiWrbgj̏ */
	TCNT0  = 0;						/* ^C}JE^NA */
	TCCR0B = 0x00;					/*    b7:FOC0A = 0 : OC0AύXȂ */
									/*    b6:FOC0B = 0 : OC0BύXȂ */
									/* b5-b4:irbgȂj               */
									/*    b3:WGM02 = 0 : Ry}b``ŃJE^NA-CTCiWGM0[1-0]=10Ƃj*/
									/* b2-b0: CS0[2-0] = 000:^C}O~ */
	TCCR0A = 0x02;					/* b7-b6:COM0A[1-0] = 00:[qOC0AI/O|[gɐݒ */
									/* b5-b4:COM0B[1-0] = 00:[qOC0BI/O|[gɐݒ */
									/* b3-b2:irbgȂj                                */
									/* b1-b0:WGM0[1-0] = 10:Ry}b``ŃJE^NA-CTCiWGM02=0Ƃj */
	OCR0A  = VAL_OCR0A-1;			/*  P̎Ԃ쐬l */
	OCR0B  = VAL_OCR0B-1;			/* 2/3̎Ԃ쐬l */
	TIFR0  = 0x07;					/* b7-b3:irbgȂj   i'1'݂̏ŃNAj */
									/*    b2:OCF0B = 1:RyA}b`a荞ݗvtONA */
									/*    b1:OCF0A = 1:RyA}b``荞ݗvtONA */
									/*    b0:TOV0  = 1:I[o[t[荞ݗvtONA   */
	TIMSK0 = 0x06;					/* b7-b3:irbgȂj                          */
									/*    b2:OCIE0B = 1:RyA}b`a荞݋ */
									/*    b1:OCIE0A = 1:RyA}b``荞݋ */
									/*    b0:TOIE0  = 0:I[o[t[荞݋֎~   */
	/* pϐ */
	s_wPulseCount = 0;
}

/******************************************************************************/
/*                       RyA}b``荞ݏ                         */
/******************************************************************************/
/* Ql : (1)TIFR0OCF0Arbg͎IɃNA                         */
/*      : (2)Ry}b``ŃJE^̓NAiCTCj                */
/*      : (3)26Si38KHzjŊ荞݂B                         */
/*      : (4)ŃLZMpX'0'(LOW)óB                     */

ISR(TIM0_COMPA_vect)
{
	CANP_OFF();						/* LZMo͒[q'0'o */
	if(s_wPulseCount == 0){
		return;
	}
	--s_wPulseCount;
	if(s_wPulseCount == 0){
		TCCR0B &= 0xF8;				/* CS0[2-0] = 000:^C}O~ */
		LED_OFF();					/* LEDCWP[^ */
	}
}

/******************************************************************************/
/*                       RyA}b`a荞ݏ                         */
/******************************************************************************/
/* Ql : (1)TIFR0OCF0Brbg͎IɃNA                         */
/*      : (2)26Si38KHzjŊ荞݂B                         */
/*      : (3)ŃLZMpX'1'(HIGH)óB                    */

ISR(TIM0_COMPB_vect)
{
	CANP_ON();						/* LZMo͒[q'1'o */
}

/******************************************************************************/
/*                     ^C}OI[o[t[荞ݏ                     */
/******************************************************************************/
/* TIFR0TOV0rbg͎IɃNA                                  */

//ISR(TIM0_OVF_vect)
//{
//	
//}

/******************************************************************************/
/*                  ԊOR̃LZMMJn                    */
/******************************************************************************/
/*  : ^C}ÕNbNPCLK/81MHz(1S)ƂȂ                        */
/*  : by100uSec = 38KHzLZMMԁi0.1mSPʁj                */
/* ߒl : Ȃ                                                                */

#define SPULSEWT	(100*64/26)			/* 0.1mS̃pX64{l */

void Send_IrRcCancel(BYTE by100uSec)
{
	BYTE	bySREG;

	/* 荞݃}XN */
	bySREG = SREG;
	cli();
	/* MԂȌꍇ͑M~ */
	if(by100uSec == 0){
		s_wPulseCount = 0;
		CANP_OFF();						/* LZMo͒[q'0'o */
		TCCR0B &= 0xF8;					/* CS0[2-0] = 000:^C}O~ */
		LED_OFF();						/* LEDCWP[^ */
	}
	else{
		/* 38KHzLZMMԃZbg */
		s_wPulseCount = ((WORD)by100uSec * SPULSEWT) >> 6;	/* Vtg1/64vZ */
		/* 38KHzLZMMJn */
		TCCR0B = (TCCR0B & 0xF8) | CLK_SEL;/* CS0[2-0] = NbNI */
		TCNT0  = 0;						/* ^C}JE^NA */
		LED_ON();						/* LEDCWP[^_ */
	}
	/* 荞݃}XNA */
	SREG = bySREG;
}

/******************************************************************************/
/*                ԊOR̃LZM𑗏oׂ              */
/******************************************************************************/
/*  :                                                                     */
/*  : Ȃ                                                                */
/* ߒl : Check_IrRcCancel() == 0 : oĂȂB                          */
/*      :                    != 0 : oB                                  */

BYTE Check_IrRcCancel(void)
{
	if(s_wPulseCount == 0){
		return 0;
	}
	return 1;
}



/* End of File */
