/******************************************************************************/
/*                   ԊORM̃wb_[M                       */
/*                                                        by : S.Suzuki       */
/******************************************************************************/
/*  : ̃vOATtiny44A-PUpłB                                */

#include <avr/io.h>
#include <avr/interrupt.h>

#include "hdwareInfo.h"
#include "IrRcReceive.h"

/******************************************************************************/
/*  : ^C}P̃NbN̓VXeNbNPCLK1/64125kHz(8S)ƂB*/
/* l : LLOW/HIGH͐ԊOMW[̏o͂B                  */
#define	HEADER_NEC	(1124)				/* LOW      8.992mS / 8S = 1124.0 */
//#define	READER_NEC	( 562)			/* HIGH     4.496mS / 8S =  562.0 */
#define HEADER_AEHA	( 425)				/* LOW        3.4mS / 8S =  425.0 */
//#define	READER_AEHA	( 212)			/* HIGH       1.7mS / 8S =  212.5 */
#define	HEADER_SONY	( 300)				/* LOW        2.4mS / 8S =  300.0 */

/******************************************************************************/

#define SEQ_NEW		(0)					/* M                     */
#define SEQ_FIRST	(1)					/* ŏ̃LAmς         */
#define SEQ_HEADER	(2)					/* wb_i[_[̓jMς */
#define	SEQ_READER	(3)					/* [_[R[hMς         */

/******************************************************************************/

static BYTE	s_byRcvValid;				/* 0=sA1=NECA2=AEHAA3=SONY */
static BYTE	s_bySeqNum;					/* MԂԍ */

/******************************************************************************/
/*               ^C}P̏ƐԊORM̎M               */
/******************************************************************************/
/* l : (1)CvbgLv`ĂJE^TCNT1̓NAȂB  */
/*      : (2)JE^TCNT1̃I[o[t[0.???bŔB               */
/*  : Ȃ                                                                */
/* ߒl : Ȃ                                                                */

void Init_TIMER1(void)
{
	/* |[g`b7(ICP1)͂ɐݒ */
	DDRA  &= 0x7F;			/* b7͂ɂ */
	PORTA |= 0x80;			/* b7̃vAbvRON */

	/* 16rbg^C}P̐ݒiCvbgLv`[hj */
	TCNT1  = 0;				/* ^C}JE^NA */
	TCCR1A = 0x00;			/* b7-b6:COM1A[1-0] = 00 : [qOC1Ȁo͑IiRyA}b`o͂Ȃj*/
							/* b5-b4:COM1B[1-0] = 00 : [qOC1B̏o͑IiRyA}b`o͂Ȃj*/
							/* b3-b2:irbgȂj                                                */
							/* b1-b0:WGM1[1-0] = 00 : g`[him[}[hj             */
	TCCR1B = 0x83;			/*    b7:ICNC1 = 1 : CvbgLv` mCYLZ     */
							/*    b6:ICES1 = 0 : CvbgLv` GbWIi0=A1=j */
							/*    b5:irbgȂj                                            */
							/* b4-b3:WGM1[3-2] = 00 : g`[him[}[hj         */
							/* b2-b0:CS1[2-0] = 011 : NbNIiPCLK/64=125kHz,8S)       */
	OCR1A  = 0;				/* RyAWX^`isgpj */
	OCR1B  = 0;				/* RyAWX^aisgpj */
	TIMSK1 = 0x00;			/* b7-b6:irbgȂj                                  */
							/*    b5:ICIE1 = 0 : CvbgLv`荞݋֎~    */
							/* b4-b3:irbgȂj                                  */
							/*    b2:OCIE1B = 0 : RyA}b`a荞݋֎~       */
							/*    b1:OCIE1A = 0 : RyA}b``荞݋֎~       */
							/*    b0:TOIE1  = 0 : I[o[t[荞݋֎~         */
	TIFR1  = 0x27;			/* b7-b6:irbgȂji'1'݂̏ŃNAj */
							/*    b5:ICF1  = 1 : CvbgLv`荞ݗv    */
							/* b4-b3:irbgȂj                                  */
							/*    b2:OCF1B = 1 : RyA}b`a荞ݗv        */
							/*    b1:OCF1A = 1 : RyA}b``荞ݗv        */
							/*    b0:TOV1  = 1 : I[o[t[荞ݗv          */

	/* Ɨpϐ */
	s_bySeqNum   = SEQ_NEW;
	s_byRcvValid = TYPE_UNDET;
}

/******************************************************************************/
/*           MpX̗^GbWmƂ̏         */
/******************************************************************************/
/*  : (1)ԊOMW[̏o͂[qICP1ɐڑĂ邽߁AICP1   */
/*      :    LOW͎̎MLA邱ƂB                          */
/*      : (2){vO͊SfR[h͍sȂȂ̂ŁAMf[^͕ۑ */
/*      :    ȂB܂As[gR[h͖ĂB                       */
/*      : (3)LŁuwb_vƏ̂Ă̂́Au[_[R[h̃LA   */
/*      :    蕔vwB                                               */

static BYTE Analysis_RcvPulse(BYTE bySeqNum, WORD wPlsWidth)
{
	/* ŏ̗茟m̏ꍇ */
	if(bySeqNum == SEQ_NEW){
		/* オ茟mɐ؂ւ */
		TCCR1B |= 0x40;
		/* ŏ̃LAm */
		return SEQ_FIRST;
	}
	/* ɍŏ̃LAmĂꍇ */
	else if(bySeqNum == SEQ_FIRST){
		/* NEC̃wb_mꍇ */
		if((HEADER_NEC-HEADER_NEC/20 <= wPlsWidth) && (wPlsWidth <= HEADER_NEC+HEADER_NEC/20)){
			/* Lȃwb_m */
			s_byRcvValid = TYPE_NEC;
		}
		/* ƓdiAEHÃwb_mꍇ */
		if((HEADER_AEHA-HEADER_AEHA/20 <= wPlsWidth) && (wPlsWidth <= HEADER_AEHA+HEADER_AEHA/20)){
			/* Lȃwb_m */
			s_byRcvValid = TYPE_AEHA;
		}
		/* SONỸwb_mꍇ */
		if((HEADER_SONY-HEADER_SONY/20 <= wPlsWidth) && (wPlsWidth <= HEADER_SONY+HEADER_SONY/20)){
			/* Lȃwb_m */
			s_byRcvValid = TYPE_SONY;
		}
	}

	/* 茟mɐ؂ւ */
	TCCR1B &= 0xBF;

	return SEQ_NEW;
}

/******************************************************************************/
/*                   ^C}P̃CvbgLv`荞                   */
/******************************************************************************/

ISR(TIM1_CAPT_vect)
{
	WORD	wCaptCnt;

	/* Lv`JEgl荞 */
	wCaptCnt = ICR1;
	/* ^C}JE^NA */
	TCNT1 = 0;
	/* MpX */
	s_bySeqNum = Analysis_RcvPulse(s_bySeqNum, wCaptCnt);
}

/******************************************************************************/
/*                     ^C}P̃I[o[t[荞                       */
/******************************************************************************/
/* l : NA???mSɔ                                             */

ISR(TIM1_OVF_vect)
{
	/* ̓wb_猟m */
	s_bySeqNum = SEQ_NEW;
	/* 茟mɐ؂ւ */
	TCCR1B &= 0xBF;
}

/******************************************************************************/
/*                      ԊOR̎Mf[^擾                      */
/******************************************************************************/
/*  : eRM`̔̓[_R[ĥ݂ł̉͂ɂA          */
/*      : ܂ł͂Ȃ߁AKvȂ邢͌młȂ  */
/*      : ꍇB                                                        */
/*  : Ȃ                                                                */
/* ߒl : Get_IrRcDetect() == TYPE_UNDET : R`sA܂͖m     */
/*      :                  == TYPE_NEC   :  NEC̃RMM         */
/*      :                  == TYPE_AEHA  : AEHÃRMM         */
/*      :                  == TYPE_SONY  : SONỸRMM         */

BYTE Get_IrRcDetect(void)
{
	BYTE	bySREG;
	BYTE	byResult;

	/* 荞݃}XN */
	bySREG = SREG;
	cli();
	/* RMMʂ𓾂 */
	byResult = s_byRcvValid;
	/* Lf[^tOZbg */
	s_byRcvValid = 0;
	/* 荞݃}XNA */
	SREG = bySREG;

	/* 	RMM̗LԂ */
	return byResult;
}

/******************************************************************************/
/*                      ԊOR̎MJn^~                      */
/******************************************************************************/
/*  : byEnable == 0:ԊOR̎M~B                          */
/*      :          != 0:ԊOR̎MJnB                          */
/* ߒl : Ȃ                                                                */

void Ctrl_IrRcReceive(BYTE byEnable)
{
	BYTE	bySREG;

	/* 荞݃}XN */
	bySREG = SREG;
	cli();
	/* ԊOR̎M~ */
	if(byEnable == 0){
		TIMSK1 = 0x00;			/* SĂ̊荞݋֎~ */
	}
	/* ԊOR̎MJn */
	else{
		TCNT1  = 0;				/* ^C}JE^NA */
		TIFR1  = 0x27;			/* SĂ̊荞ݗvtONA */
		TIMSK1 = 0x21;			/* CvbgLv`荞݋AI[o[t[荞݋ */
	}
	/* 茟mɐ؂ւ */
	TCCR1B &= 0xBF;
	/* R` */
	s_byRcvValid = TYPE_UNDET;
	/* ̓wb_猟m */
	s_bySeqNum = SEQ_NEW;
	/* 荞݃}XNA */
	SREG = bySREG;
}


/* End of File */
